#ifndef CORE_VIEW_H
#define CORE_VIEW_H

#include "core/Matrix.h"

typedef struct {
    CoreMatrix view;
    CoreVector3 back;
    CoreVector3 down;
    CoreVector3 front;
    CoreVector3 left;
    CoreVector3 right;
    CoreVector3 up;
} CoreView;

void coreInitView(CoreView* v);
void coreUpdateDirections(CoreView* v, float lengthAngle, float widthAngle);
void coreUpdateDirectionsQ(CoreView* v, const CoreQuaternion* q);
CoreMatrix* coreUpdateMatrix(CoreView* v, const CoreVector3* pos);

#ifdef IMPORT_CORE
#define View CoreView
#define initView coreInitView
#define updateDirections coreUpdateDirections
#define updateDirectionsQ coreUpdateDirectionsQ
#define updateMatrix coreUpdateMatrix
#endif

#endif
